/*
*  Licensed Materials - Property of IBM
*  5725-G92 (C) Copyright IBM Corp. 2006, 2012. All Rights Reserved.
*  US Government Users Restricted Rights - Use, duplication or
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/

window.$ = window.jQuery = WLJQ;

var feeds = null;

$(".FeedItem").live("click", function(){
	displayFeed($(this).attr("id"));
});

function loadFeeds(){
	$.mobile.showPageLoadingMsg();
	var invocationData = {
			adapter: "WorklightStarterAdapter",
			procedure: "getEngadgetFeeds",
			parameters: [true]
	};
	
	WL.Client.invokeProcedure(invocationData, {
		onSuccess: loadFeedsOK, 
		onFailure: loadFeedsFAIL
	});
}

function loadFeedsOK(data){
	if (!data || !data.invocationResult || !data.invocationResult.items || data.invocationResult.items.length==0)
		showErrorMessage("Could not retrieve feeds");
	
	feeds = data.invocationResult.items;
	$("#FeedsList").empty();
	
	for (var i=0; i<feeds.length; i++){
		var dataItem = feeds[i];
		var listItem = $("<li class='FeedItem' id='" + i + "'><a href='#'><h3>" + dataItem.title + "</h3><p>"+ dataItem.pubDate+"</p></a></li>");
		$("#FeedsList").append(listItem);
	}
	
	$("#FeedsList").listview('refresh');
	$.mobile.hidePageLoadingMsg();
}

function loadFeedsFAIL(data){
	showErrorMessage("Server connectivity error");
}

function displayFeed(feedId){
	$.mobile.showPageLoadingMsg();
	var itemHtml = feeds[feedId].description;
	var item = $(itemHtml);
	
	$(item).find("img").each(function(){
		if ($(this).attr("src").indexOf("jpg")>=0)
			$(this).width(260);
	});
	
	$("#FeedContent").html(item);
	$("#FeedContent a").attr("target","_blank");

	setTimeout(function(){
		$.mobile.hidePageLoadingMsg();
		$.mobile.changePage("#FeedContentPage");
	}, 0);
	
}

function showErrorMessage(text){
	$.mobile.hidePageLoadingMsg();
	$("#DialogText").html(text);
	$.mobile.changePage("#DialogPage");
}

function wlCommonInit(){
	loadFeeds();
}

